/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"fmt"
)

// NotificationFrequency the model 'NotificationFrequency'
type NotificationFrequency string

// List of NotificationFrequency
const (
	INSTANT NotificationFrequency = "instant"
	HOURLY NotificationFrequency = "hourly"
	DAILY NotificationFrequency = "daily"
)

// All allowed values of NotificationFrequency enum
var AllowedNotificationFrequencyEnumValues = []NotificationFrequency{
	"instant",
	"hourly",
	"daily",
}

func (v *NotificationFrequency) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := NotificationFrequency(value)
	for _, existing := range AllowedNotificationFrequencyEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid NotificationFrequency", value)
}

// NewNotificationFrequencyFromValue returns a pointer to a valid NotificationFrequency
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewNotificationFrequencyFromValue(v string) (*NotificationFrequency, error) {
	ev := NotificationFrequency(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for NotificationFrequency: valid values are %v", v, AllowedNotificationFrequencyEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v NotificationFrequency) IsValid() bool {
	for _, existing := range AllowedNotificationFrequencyEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to NotificationFrequency value
func (v NotificationFrequency) Ptr() *NotificationFrequency {
	return &v
}

type NullableNotificationFrequency struct {
	value *NotificationFrequency
	isSet bool
}

func (v NullableNotificationFrequency) Get() *NotificationFrequency {
	return v.value
}

func (v *NullableNotificationFrequency) Set(val *NotificationFrequency) {
	v.value = val
	v.isSet = true
}

func (v NullableNotificationFrequency) IsSet() bool {
	return v.isSet
}

func (v *NullableNotificationFrequency) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableNotificationFrequency(val *NotificationFrequency) *NullableNotificationFrequency {
	return &NullableNotificationFrequency{value: val, isSet: true}
}

func (v NullableNotificationFrequency) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableNotificationFrequency) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

